//
//  AGUpdateFeed.h
//  AraeliumUpdate
//
//  Created by Seth Willits on 8/14/12.
//  Copyright (c) 2012 Araelium Group. All rights reserved.
//

#import <Foundation/Foundation.h>
@class AGUpdate;
@class AGUpdateSystemProfile;


@interface AGUpdateFeed : NSObject
{
	void (^mCompletionHandler)(AGUpdateFeed * feed, NSError * error);
	NSURL * mURL;
	AGUpdateSystemProfile * mProfile;
	NSDictionary * mExtraParams;
	NSArray * mUpdates;
	AGUpdate * mRecommendedUpdate;
}

@property (readonly) NSURL * URL;
@property (readonly) NSArray<AGUpdate *> * updates;
@property (readonly) AGUpdate * recommendedUpdate;

+ (void)fetchFeedAtURL:(NSURL *)url
			parameters:(NSDictionary *)params
			   profile:(AGUpdateSystemProfile *)profile
	 completionHandler:(void (^)(AGUpdateFeed * feed, NSError * error))handler;

@end
